//+------------------------------------------------------------------+
//|                                       TrendStrengthExpert_v2.mq4 |
//|                           Copyright  2007, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string Expert_Name    = "Jurik_TrendStrength";
extern bool   NoHedge        = false;
extern bool   StrictNoHedge  = false;
extern string SymbolsPrefix  = "";
extern string SymbolsSuffix  = "";
extern bool   UseAutoMagic   = true;
extern int    ManualMagic    = 123123123; 
extern bool   EcnBroker      = true;
extern int    Slippage       = 3;

extern string Main_data      = "Trade Volume & Trade Method";
extern double Lots           = 0.1;      // Trade Volume 
extern int    MaxOrders      = 1;
extern double TakeProfit     = 0;        // Take Profit Value in pips 
extern double StopLoss       = 75;        // Initial Stop Value in pips 
extern double TrailingStop   = 35;        // Trailing Stop Value in pips
extern double MoneyRisk      = 1;        // Deviation of VoltyChannel_Stop or MoneyRisk
extern double BreakEven      = 0;        // Break-Even Value in pips
extern double ProfitLock     = 0;        // Profit Lock in pips
extern int    ExitMode       = 0;        // System Exit Switch:0-off,1-TS,2-TE,3-AddSignal,4-any first,5-signal
extern bool   SignalMail     = false;    // E-mail Alert Switch

extern string Time_Inputs    = "Timing parameters";
extern int    MainTimeFrame  = 0;        // Time Frame in min
extern int    StartHour      = 19;       // Start Hour of Trade Session 
extern int    StartMinute    = 15;       // Start Minute of Trade Session 
extern int    EndHour        = 6;        // End Hour of Trade Session
extern int    EndMinute      = 45;       // End Hour of Trade Session
extern int    MonStartHour   = 0;        // Monday Start Hour of Trade Session 
extern int    MonStartMinute = 15;       // Monday Start Minute of Trade Session 
extern int    FriEndHour     = 6;        // Friday End Hour of Trade Session
extern int    FriEndMinute   = 45;       // Friday End Hour of Trade Session
extern int    TradeDay       = -1;       // Trade Day of Week (ex.1-Monday,-1-all Days) 
extern int    NonTradeDay    = 0;        // Non-Trading Day of Week (ex.5-Friday)   
extern int    CloseTimeMode  = 0;        // CloseTime mode: 0-off,1-on
extern int    CloseHour      = 24;       // Trade Close Hour   
extern int    CloseMinute    = 0;        // Trade Close Minute   
extern int    FriCloseHour   = 22;       // Trade Close Hour in Friday   
extern int    FriCloseMinute = 55;       // Trade Close Minute in Friday 
extern double ProcessTime    = 3;        // Process Time for Close Orders by Time
extern double OrdDuration    = 1.5;      // Min Orders duration

extern string TE_Inputs      = "JurikTrendEnvelope parameters";
extern int    TE_TimeFrame   = 0;        // Time Frame in min
extern int    TE_Length      = 14;
extern double TE_Phase       = 0;
extern bool   TE_Double      = false;
extern int    TE_UpperPrice  = PRICE_HIGH;
extern int    TE_LowerPrice  = PRICE_LOW;
extern double TE_Deviation   = 0.2;
extern int    TE_CurBar      = 1;        // Shift relative to the current bar
extern int    TE_Mode        = 0;        // TE Mode: 0-off,1-trend(confirmation),2-signal

extern string VS_Inputs      = "VoltyChannel_Stop parameters";
extern int    VS_TimeFrame   = 0;        // Time Frame in min
extern int    VS_Price       = 0;
extern double VS_SmoothLength= 21;
extern double VS_SmoothPhase = 0;
extern bool   VS_SmoothDouble= false;
extern int    VS_ATRLength   = 10; 
extern double VS_Kv          = 4;  
extern double VS_MoneyRisk   = 1; 
extern int    VS_CurBar      = 1;        // Shift relative to the current bar
extern int    VS_Mode        = 1;        // VS Mode: 0-off,1-trend(confirmation),2-signal

extern string TS_Inputs      = "TrendStrength parameters";
extern int    TS_TimeFrame   = 0;        // Time Frame in min
extern int    TS_Price       = 8;
extern double TS_RsxLength   = 14;       // Period of evaluation
extern int    TS_SmoothPhase = 0;        // Period of smoothing
extern bool   TS_SmoothDouble= false;
extern int    TS_CurBar      = 1;        // Shift relative to the current bar
extern int    TS_Mode        = 2;        // TS Mode: 0-off,1-trend(confirmation),2-signal
extern double buylevel       = 30;
extern double sellevel       = 70;

extern string AS_Inputs      = "AbsoluteStrength parameters";
extern int    AS_TimeFrame   = 0;        // Time Frame in min
extern int    AS_MathMode    = 1;        // 0-RSI method; 1-Stoch method; 2-ADX method
extern int    AS_Length      = 10;       // Period of evaluation
extern int    AS_Signal      = 5;        // Period of smoothing
extern int    AS_Smooth      = 5;        // Period of Signal Line
extern int    AS_Price       = 0;        // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    AS_ModeMa      = 3;        // Mode of Moving Average
extern int    AS_CurBar      = 1;        // Shift relative to the current bar
extern int    AS_Mode        = 1;        // Add Mode: 0-off,1-trend(confirmation),2-signal

extern string MM_inputs      = "MoneyManagement by L.Williams ";
extern bool   MM             = false;    //  Switch
extern double MaxRisk        = 0.05;     // Risk Factor
extern double MaxLoss        = 1000;     // Maximum Loss by 1 Lot

//
//
//
//
//

int      OrderBar=0;
int      BEvent=0, TriesNum=5;
int      Magic;

datetime CurrBar,PrevBar;

double   Lotsi;
double   UpLine, DnLine;
double   TStrend, pTStrend, VStrend, pVStrend, Addtrend, pAddtrend, TEtrend, pTEtrend;
double   Bulls, sBulls, Bears, sBears;
double   pipMultiplier = 1;

string   s_symbol;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

  s_symbol = Symbol();
  if (UseAutoMagic) Magic = GetMagic();
              else  Magic = ManualMagic;  
    
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);

return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()  {   return(0);  }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if (Digits == 3 || Digits == 5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;
   
   //
   //
   //
   //
   //
     
   if (TE_TimeFrame==0) TE_TimeFrame = Period();
   if (TS_TimeFrame==0) TS_TimeFrame = Period();
   if (VS_TimeFrame==0) VS_TimeFrame = Period(); 
   if (AS_TimeFrame==0) AS_TimeFrame = Period(); 
   
   //
   //
   //
   //
   //
   
   if(iBars(Symbol(),VS_TimeFrame) < 100 || IsTradeAllowed()==false) return(0); 
   
   //
   //
   //
   //
   //
      
   if (AccountFreeMargin() < (100 * MoneyManagement())) { Print("We have no money. Free Margin = ", AccountFreeMargin()); return(0); }
   
   //
   //
   //
   //
   //
   
       CurrBar  = iTime(Symbol(),0,0);
   if (CurrBar != PrevBar)
   {
      
      //
      //
      //
      //
      //
      
      int Signal = TradeSignal();    
      if (ScanTrades() > 0)
      {
      
      //
      //
      //
      //
      //
      
        if (ExitMode == 1)
        {
          if (TStrend > 0 && pTStrend < 0) CloseOrder(2);
          if (TStrend < 0 && pTStrend > 0) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 2)
        {
          if (TEtrend > 0 && pTEtrend < 0) CloseOrder(2);
          if (TEtrend < 0 && pTEtrend > 0) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 3)
        {
          if (VStrend > 0 && pVStrend < 0) CloseOrder(2);
          if (VStrend < 0 && pVStrend > 0) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 4)
        {
           if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0) || (TEtrend > 0 && pTEtrend < 0)) CloseOrder(2);
           if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0) || (TEtrend < 0 && pTEtrend > 0)) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 5)
        {
          if (Signal > 0) CloseOrder(2);
          if (Signal < 0) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 6)
        {
          if ((TStrend > 0 && pTStrend < 0)||(VStrend > 0 && pVStrend < 0)||(Bulls > sBulls && Bulls > Bears)) CloseOrder(2);
          if ((TStrend < 0 && pTStrend > 0)||(VStrend < 0 && pVStrend > 0)||(Bears > sBears && Bulls < Bears)) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 7)
        {
          if ((Bulls > sBulls)||(Bears < sBears)) CloseOrder(2);
          if ((Bulls < sBulls)||(Bears > sBears)) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        else
        if (ExitMode == 8)
        {
          if ((TStrend > 0 && pTStrend < 0)||(Bulls > sBulls)) CloseOrder(2);
          if ((TStrend < 0 && pTStrend > 0)||(Bears > sBears)) CloseOrder(1);
        }
        
        //
        //
        //
        //
        //
        
        if (CloseTimeMode > 0)
        {
          datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
          if (DayOfWeek() == 5) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute);
          if (TimeCurrent() >=  TimeClose && TimeCurrent() < TimeClose+ProcessTime*60) CloseOrder(0); 
        }
        }
        //
        //
        //
        //
        //
      
        if (ScanTrades() < MaxOrders)
        {
          if (Signal > 0 && canOpen(OP_BUY)  && TimeCondition())  BuyOrdOpen() ;
          if (Signal < 0 && canOpen(OP_SELL) && TimeCondition())  SellOrdOpen();
        }
       }
       
       //
       //
       //
       //
       //
        
       else
       if (ScanTrades() > 0)
       {
         if (TrailingStop > 0 || BreakEven > 0) TrailStop();
       }
   PrevBar = CurrBar;
   
return(0);
} 

//
//
//
//
//

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {  
         
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == s_symbol && OrderType() <= OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
    
      if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
      {
         if(StartHour == 24) StartHour = 0; 
      
         datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
         double   Start        = StartHour + StartMinute/60.0;
         datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
         double   End          = EndHour + EndMinute/60.0; 
         
         //
         //
         //
         //
         //
         
         if(DayOfWeek() != 1 && DayOfWeek() != 5)
         {    
            if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);  
                
            else
            if (Start > End)result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
                                   
         }
         else
         if(DayOfWeek() == 1)
         {    
            if(MonStartHour > 0 || MonStartMinute > 0) 
            {
            datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
            double   MonStart        = MonStartHour + MonStartMinute/60.0;
            }
            else
            {
            MonSessionStart = StrToTime(0+":"+0); 
            MonStart        = 0;
            }
            
            //
            //
            //
            //
            //
                        
            if (Start < End)
            { 
              if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
                            else result = TimeCurrent() >= SessionStart    && TimeCurrent() < SessionEnd;
            }
            else
            if (Start > End)
            {
               result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd)|| (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59)); 
                     
            }
         }
         else
         if(DayOfWeek() == 5)
         {
            if(FriEndHour > 0 || FriEndMinute > 0)
            {
            datetime FriSessionEnd = StrToTime(FriEndHour+":"+FriEndMinute);
            double   FriEnd        = FriEndHour + FriEndMinute/60.0; 
            }
            else
            {
            FriSessionEnd = SessionEnd;
            FriEnd        = End; 
            }
            
            //
            //
            //
            //
            //
            
            if (Start < End)
            {
              if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
                            else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;                 
            }
            
            else
            if (Start > End)
               result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
                           
         }  
      }
   
   return(result);
}   

//
//
//
//
//
   
int TS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TStrend  = iCustom(Symbol(),TS_TimeFrame,"rsx on jurik smooth",0,TS_Price,TS_RsxLength,TS_SmoothPhase,TS_SmoothDouble,0,TS_CurBar);
   pTStrend = iCustom(Symbol(),TS_TimeFrame,"rsx on jurik smooth",0,TS_Price,TS_RsxLength,TS_SmoothPhase,TS_SmoothDouble,0,TS_CurBar+1);
   
   //
   //
   //
   //
   //
          
   if (mode == 1)
   {
     if (TStrend < buylevel) result =  mode;
     if (TStrend > sellevel) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
     if (TStrend < buylevel && pTStrend < TStrend) result =  mode;  
     if (TStrend > sellevel && pTStrend > TStrend) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

//
//
//
//
//

int TE_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   TEtrend  = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar);
   pTEtrend = iCustom(Symbol(),TE_TimeFrame,"jurik trendenvelopes for ea",0,TE_Length,TE_Phase,TE_Double,TE_UpperPrice,TE_LowerPrice,TE_Deviation,6,TE_CurBar+1);
   
   // 
   //
   //
   //
   //
       
   if (mode == 1)
   {
     if (TEtrend > 0) result =  mode;
     if (TEtrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
     if (TEtrend > 0 && pTEtrend < 0) result =  mode;  
     if (TEtrend < 0 && pTEtrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
return(result); 
}

int VS_Trend(int mode)
{   
   int result = 0; 
   
   //
   //
   //
   //
   //
   
   VStrend  = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar);
   pVStrend = iCustom(Symbol(),VS_TimeFrame,"Volty Channel Stop on jurik-for Ea",0,VS_Price,VS_SmoothLength,VS_SmoothPhase,VS_SmoothDouble,VS_ATRLength,VS_Kv,VS_MoneyRisk,0,6,VS_CurBar+1);
   
   //
   //
   //
   //
   //
         
   if (mode == 1)
   {
     if (VStrend > 0) result =  mode;
     if (VStrend < 0) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
     if (VStrend > 0 && pVStrend < 0) result =  mode;  
     if (VStrend < 0 && pVStrend > 0) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//
//
//
//
//

int AbStrength(int mode)
{   
   int result = 0; 
   
   Bulls  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength",0,AS_MathMode,AS_Length,AS_Signal,AS_Smooth,AS_Price,AS_ModeMa,0,0,0,AS_CurBar);
   sBulls = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength",0,AS_MathMode,AS_Length,AS_Signal,AS_Smooth,AS_Price,AS_ModeMa,0,0,2,AS_CurBar);
   
   Bears  = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength",0,AS_MathMode,AS_Length,AS_Signal,AS_Smooth,AS_Price,AS_ModeMa,0,0,1,AS_CurBar);
   sBears = iCustom(Symbol(),AS_TimeFrame,"AbsoluteStrength",0,AS_MathMode,AS_Length,AS_Signal,AS_Smooth,AS_Price,AS_ModeMa,0,0,3,AS_CurBar);
   
   //
   //
   //
   //
   //
   
   if (mode == 1)
   {
     if (Bulls > sBulls) result =  mode;
     if (Bears > sBears) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if (mode == 2)
   {
     if (Bulls > sBulls && Bulls > Bears) result =  mode;
     if (Bears > sBears && Bulls < Bears) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//
//
//
//
//

int TradeSignal()
{   
   int Signal =0;
   
   //
   //
   //
   //
   //
   
   if (TS_Mode > 0 || ExitMode == 1 || ExitMode == 5 || ExitMode == 6 || ExitMode == 8) int TS = TS_Trend(TS_Mode);   else TS = 0;
   if (TE_Mode > 0 || ExitMode == 2 || ExitMode == 5)                                   int TE = TE_Trend(TE_Mode);   else TE = 0;
   if (VS_Mode > 0 || ExitMode == 3 || ExitMode == 5 || ExitMode == 6)                  int VS = VS_Trend(VS_Mode);   else VS = 0; 
   if (AS_Mode > 0 || ExitMode  > 5)                                                    int AS = AbStrength(AS_Mode); else AS = 0;    
     
   // 
   //
   //
   //
   // 
   
   if (TimeCondition())
   {
     if (TE == TE_Mode && VS == VS_Mode && TS == TS_Mode && AS == AS_Mode) Signal = 1;
     if (TE ==-TE_Mode && VS ==-VS_Mode && TS ==-TS_Mode && AS ==-AS_Mode) Signal =-1;
   }  
 
return(Signal);
}

//
//
//
//
//

double MoneyManagement()
{
   double lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   double lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   double lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   double contract = MarketInfo(Symbol(),MODE_LOTSIZE);
   double vol;
   
   //
   //
   //
   //
   //
   
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage() <= 0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   //
   //
   //
   //
   //
   
   if (MM)
   {
      if (MaxLoss>0) vol = NormalizeDouble(AccountFreeMargin()*MaxRisk/MaxLoss,2);
      else   
      vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2);
   }
   else
   vol=Lots;
   
   //
   //
   //
   //
   //
   
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if(vol<lot_min) vol=lot_min;
   if(vol>lot_max) vol=lot_max;

return(vol);
}   

//
//
//
//
//

void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   
   //
   //
   //
   //
   //
    
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode = OrderType();    
      if (OrderSymbol() == s_symbol && OrderMagicNumber() == Magic) 
      {
        if (mode==OP_BUY) 
        {
			 if (BreakEven > 0 && BEvent == 0 )
			 {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/Point*pipMultiplier;
			      if( Gain >= BreakEven && OrderStopLoss() <= OrderOpenPrice()+ProfitLock*Point*pipMultiplier) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+ProfitLock*Point*pipMultiplier,Digits);
			      BEvent=1;
			      }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else 			   
			   if( TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*Point*pipMultiplier,Digits);
			   
			   //
			   //
			   //
			   //
			   //
			   
			   if(NormalizeDouble(OrderOpenPrice(),Digits) <= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result   =  OrderModify(OrderTicket(),OrderOpenPrice(),BuyStop,OrderTakeProfit(),0,Lime);
                  error    =  GetLastError();
                  if(error == 0) break;
                  else { Sleep(5000); RefreshRates(); continue; }
                  }   		 
               }            
            }
         }  
         
         //
         //
         //
         // 
         // 
                  
         if (mode==OP_SELL)
         {
           if (BreakEven > 0 && BEvent == 0)
			  {
			     Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/Point*pipMultiplier;
			   
			     if( Gain >= BreakEven && (OrderStopLoss() >= OrderOpenPrice()-ProfitLock*Point*pipMultiplier || OrderStopLoss()== 0)) 
			     {
			     double SellStop = NormalizeDouble(OrderOpenPrice()-ProfitLock*Point*pipMultiplier,Digits);
			     BEvent=-1;
			     }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else 
			   if (TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*Point*pipMultiplier,Digits); 
			   
			   //
			   //
			   //
			   //
			   //
                        
            if (NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop > 0) 
            {
              if (SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
              {
                for (k = 0 ; k < TriesNum; k++)
                {
                  result    = OrderModify(OrderTicket(),OrderOpenPrice(),SellStop,OrderTakeProfit(),0,Orange);
                  error     = GetLastError();
                  if(error == 0) break;
                  else { Sleep(5000); RefreshRates(); continue; }
                  }
               }   
   			}	    
         }
      }
   }     
}

// 
//
//
//
//

void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
   
   //
   //
   //
   //
   //
       	  
   if (StopLoss > 0) double SellStop  = StopPrice + StopLoss*Point*pipMultiplier; 
	else 
   
   //
   //
   //
   //
   
   if (TakeProfit > 0) double SellProfit = SellPrice - TakeProfit*Point*pipMultiplier; else SellProfit=0;
   
   //
   //
   //
   //
   //
   
   if (!EcnBroker) 
	      OrderSend(s_symbol,Mode,MoneyManagement(),NormalizeDouble(SellPrice,Digits),Slippage*Point*pipMultiplier,NormalizeDouble(SellStop,Digits),
	                NormalizeDouble(SellProfit,Digits),Expert_Name+"SELL",Magic,0,Red);
	else
   {
    int sellTicket = OrderSend(s_symbol,Mode,MoneyManagement(),NormalizeDouble(SellPrice,Digits),Slippage*Point*pipMultiplier,0,0,Expert_Name+"SELL",Magic,0,Red);	    		   
   
    if (sellTicket >= 0) 
      int sellOrderMod = OrderModify(sellTicket,OrderOpenPrice(),SellStop,SellProfit,0,CLR_NONE);
      if (OrderSelect(sellTicket, SELECT_BY_TICKET, MODE_TRADES)) 
      {
      
      //
      //
      //
      //
		//
		
		Print("SELL order opened : ", OrderOpenPrice());
      BEvent = 0;
      if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Bid,Digits) + " Open Sell");
		}
	else 	
   if(GetLastError() > 0)
   Print("SELL: OrderSend failed with error #",GetLastError());
  } 
return(0);
}

//
//
//
//
// 

void BuyOrdOpen()
{		     
   double BuyPrice  = Ask;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
   
   //
   //
   //
   //
   //
      
   if (StopLoss > 0) double BuyStop  = StopPrice - StopLoss*Point*pipMultiplier; 
	else 
   
   //
   //
   //
   //
   //
   
   if (TakeProfit > 0) double BuyProfit = BuyPrice + TakeProfit*Point*pipMultiplier; else BuyProfit=0;  
	
	//
	//
	//
	//
	//
	if (!EcnBroker) 	 
	      OrderSend(s_symbol,Mode,MoneyManagement(),NormalizeDouble(BuyPrice,Digits),Slippage*Point*pipMultiplier,NormalizeDouble(BuyStop,Digits), 
	                NormalizeDouble(BuyProfit,Digits),Expert_Name+" BUY",Magic,0,Blue);
	else
   {
  
         int buyTicket = OrderSend(s_symbol,Mode,MoneyManagement(),NormalizeDouble(BuyPrice,Digits),Slippage*Point*pipMultiplier,0,0,Expert_Name+" BUY",Magic,0,Blue);	
         	    		    
         if (buyTicket >= 0)
         bool buyOrderMod = OrderModify(buyTicket,OrderOpenPrice(),BuyStop,BuyProfit,0,CLR_NONE);
         if (OrderSelect(buyTicket, SELECT_BY_TICKET, MODE_TRADES)) 
         {
         
         //
         //
         //
         //
		   // 
		   
		   Print("BUY order opened : ", OrderOpenPrice());
         BEvent = 0;
         if (SignalMail) SendMail("[Signal Alert]", "[" + Symbol() + "] " + DoubleToStr(Ask,Digits) + " Open Buy");
		   }
	else 	
   if(GetLastError() > 0)      
   Print("BUY : OrderSend failed with error #",GetLastError());
 }

return(0);
} 

//
//
//
//
//

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   //
   //
   //
   //
   //
   
   for (int i=0; i<=OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == s_symbol) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua);
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) result=CloseAtMarket(OrderTicket(),OrderLots(),Pink);
      }
   }
}

//
//
//
//
//

bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      //
      //
      //
      //
      //
      
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage*Point*pipMultiplier,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if (OrderSymbol() !=  s_symbol)                      continue;
      if (!StrictNoHedge && OrderMagicNumber() != Magic)   continue;
      
      if (OrderType() == OP_BUY  && openWhat == OP_SELL)   return(false); 
      if (OrderType() == OP_SELL && openWhat == OP_BUY)    return(false); 
   }      
   return(true);
}

//
//
//
//
//

int GetMagic() 
{

   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(11933921);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(11933922);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(11933931);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(11933932);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(11933941);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(11933942);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(11933951);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(11933961);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(11933962);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(11933963);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(11933964);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(11933965);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(11933966);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(11933967);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(11933971);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(11933972);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(11933973);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(11933981);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(11933982);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(11933983);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(11933991);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(11933992);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(11933993);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(11933994);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(11933995);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
   return(ManualMagic);
}


